PFont fonte1, fonte2, fonte3, fonte4, fonte5, fonte6, fonte7;
PImage atomo, start, forw, lambda, theta, ret, constr, destr, bragg, back;
float mouse_x, mouse_y, t0 = 0, time, t1 = 0, t2 = 0, t3 = 0, t4 = 0, t5 = 0, t6 = 0, t, x_sin, y_sin, amplitude = 24, angle_sin, prevX, prevY, numOfWaves = 11, amplitude2, numOfWaves2 = 18, next = 0;
int count, passe1 = 0, count2, interf = 1, window = 0, sub_w = 1;
boolean play = false, passe2 = false, passe3 = false, passe4 = false, passe5 = false, passe6 = false;

void setup() {
 size(800, 600);
 background(255);
 fonte1 = loadFont("Corbel-BoldItalic-36.vlw");
 fonte2 = loadFont("Corbel-30.vlw");
 fonte3 = loadFont("Corbel-Bold-20.vlw");
 fonte4 = loadFont("Calibri-20.vlw");
 fonte5 = loadFont("Calibri-16.vlw");
 fonte6 = loadFont("Calibri-14.vlw");
 fonte7 = loadFont("Calibri-12.vlw");
 atomo = loadImage("sphere.png");
 start = loadImage("play.png");
 forw = loadImage("forw.png");
 lambda = loadImage("lambda.png");
 theta = loadImage("theta.gif");
 ret = loadImage("return.png");
 constr = loadImage("const.png");
 destr = loadImage("dest.png");
 bragg = loadImage("bragg.png");
 back = loadImage("back.png");

}
void draw() {
   background(255);
   textFont(fonte1);
   fill(0);
   smooth();
   time = millis();
   textAlign(CENTER);
   text("Difração de Raios-X", 400, 40);
   textFont(fonte2);
   text("Lei de Bragg", 400, 80);
   if(interf == 1) {
     fill(204, 0, 0);
     stroke(204, 0, 0);
   }
   else {
     fill(255, 121, 121);
     stroke(255, 121, 121);
   }
   rect(290, 110, 100, 25);
   if(interf == 2) {
     fill(204, 0, 0);
     stroke(204, 0, 0);
   }
   else {
     fill(240, 94, 94);
     stroke(240, 94, 94);
   }
   rect(410, 110, 100, 25);
   fill(255);
   textFont(fonte3);
   text("Máximos", 290, 113, 100, 25);
   text("Mínimos", 410, 113, 100, 25);
   noFill();
   if(play == false) {
     image(start, 430, 515, 32, 32);
     fill(0);
     textFont(fonte2);
     text("Iniciar", 378, 540);
   }
   fill(0);
    
  //translate aqui para aumentar o espaço para texto
  pushMatrix();
  translate(0, -50);  
  //primeiro plano
  image(atomo, 70, 300, 30, 30);
  image(atomo, 227.5, 300, 30, 30);
  image(atomo, 385, 300, 30, 30);
  image(atomo, 542.5, 300, 30, 30);
  image(atomo, 700, 300, 30, 30);
  //segundo plano
  image(atomo, 70, 470, 30, 30);
  image(atomo, 227.5, 470, 30, 30);
  image(atomo, 385, 470, 30, 30);
  image(atomo, 542.5, 470, 30, 30);
  image(atomo, 700, 470, 30, 30);
  
  smooth();
  if(passe2 == false)
    noStroke();
  else
    stroke(255, 218, 5);
  strokeWeight(2);
  pushMatrix();
  translate(400, 470 + amplitude/2);
  scale(1, -1);
  rotate(radians(36));
 //onda que atinge o segundo plano
  for(count=0; count < 605 && play == true && interf == 1; ++count) {
    x_sin = count;
 
    angle_sin = radians(count);
    y_sin = sin(angle_sin*(numOfWaves/0.8));
 
    y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
    
    if(count >= -1*(time - t0 - 604*20)/20 && t0 != 0 && passe2 == false) {
      stroke(255, 218, 5);
      if(count == 0) {
        passe2 = true;
        if(t3 == 0)
          t3 = millis();
      }
    }
    
    
    if(count <= (t - t2 - 3000)/50 && t2 != 0 && count <= 26 && passe1 > 0)
      stroke(255, 0, 0);
    if(count <= (t - t2 - 6000)/50 && t2 != 0 && count > 26 && count <= 52 && passe1 > 1)
      stroke(255, 0, 0);
    if(count <= (t - t2 - 9000)/50 && t2 != 0 && count > 52 && count <= 78 && passe1 > 2)
      stroke(255, 0, 0);
    if(count <= (t - t2 - 12000)/50 && t2 != 0 && count > 78 && count <= 104 && passe1 > 3)
      stroke(255, 0, 0);
    
    line(prevX, prevY, x_sin, y_sin);
    if(passe2 == true)
      stroke(255, 218, 5);
    prevX = x_sin;
    prevY = y_sin;
  }
 
  prevX = prevY = 0.0;
  
  popMatrix();
  //numeração das ondas
  if(interf == 1) {
    if(t - t0 >= 1500 && t0 != 0) {
      text("1", 785, 66);
      text("2", 785, 180);
    }
    if(passe2 == true && passe3 == true) {
      text("1'", 380, 270);
      text("2'", 376, 438);
    }
  }
  else {
    if(t - t0 >= 1500 && t0 != 0) {
      text("3", 785, 178);
      text("4", 785, 332);
    }
    if(passe2 == true && passe3 == true) {
      text("3'", 380, 273);
      text("4'", 376, 438);
    }
  }
  //onda que atinge o primeiro plano
  pushMatrix();
  translate(400, 300 + amplitude/2);
  scale(1, -1);
  rotate(radians(36));
  if(passe2 == false)
    noStroke();
  else
    stroke(255, 218, 5);
  for(int count=0; count < 500 && play == true && interf == 1; ++count) {
    x_sin = count;
 
    angle_sin = radians(count);
    y_sin = sin(angle_sin*(numOfWaves/0.8));
 
    y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
    
    if(count >= -1*(time - t0 - 499*20)/20 && t0 != 0 && passe2 == false) {
      stroke(255, 218, 5);
      if(count == 0) {
        passe3 = true;
        if(t4 == 0)
          t4 = millis();
      }
    }
 
    line(prevX, prevY, x_sin, y_sin);
    
    prevX = x_sin;
    prevY = y_sin;
  }
 
  prevX = prevY = 0.0;
  
  popMatrix();
  if(play == true && interf == 1) {
    
    if(next == 0) {
      textFont(fonte5);
      text("O raios-X que incidem no cristal são paralelos e estão em fase. O ângulo de incidência é de 54°. O raio 1 incide no primeiro plano atômico do cristal, enquanto o raio 2 incide no segundo plano atômico. Dessa forma, o caminho percorrido pelos dois raios-X é diferente: o raio 2 percorre o trajeto mais longo. ", 30, 530, 740, 100);
      if(passe4 == true && passe5 == true) {
        image(forw, 740, 600, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 622); 
      }
    }
    else if(next == 1) {
      textFont(fonte6);
      text("Os máximos de difração - decorrentes da interferência construtiva dos raios-X - acontecem para ângulos de incidência tais que a diferença de percurso dos dois raios-X corresponda a um número inteiro de comprimentos de onda. Observe que a diferença de percurso dos raios incidentes é delimitada pela reta pontilhada partindo do ponto de incidência do raio 1, com direção perpendicular à direção de propagação dos raios-X incidentes. Um a um, os comprimentos de onda contidos nesta diferença de percurso são destacados em vermelho.", 20, 530, 760, 250);
      if(passe1 == 5) {
        image(forw, 740, 610, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 632);
      }
    }
    else if(next == 2) {
      textFont(fonte6);
      text("Para delimitar a diferença de percurso dos raios difratados, procede-se da mesma forma que com os raios incidentes. Traça-se uma reta pontilhada partindo do átomo de incidência do raio 1, perpendicularmente à direção de propagação dos raios-X difratados. Os comprimentos de onda contidos na diferença de percurso são contados e destacados em vermelho. Como você pode verificar ao fim da animação, são 8 os comprimentos de onda contidos na diferença total de percurso. Portanto, há interferência construtiva e o ângulo de incidência de 54° configura um máximo de difração. Observe que isto acontece porque, a partir da linha pontilhada, os raios difratados 1' e 2' deixam o cristal em fase.", 15, 515, 770, 200);
      if(passe1 == 10) {
        image(ret, 740, 615, 24, 24);
        textFont(fonte4);
        text("Reiniciar", 694, 632);
      }
    }
    t = millis();
    if(t1 == 0 && next == 1)
      t1 = millis();
    if(t - t1 > 3000 && t1 != 0) {
      if(passe6 == false) {
        stroke(0);
        fill(0);
        dottedLine(400, 315, 484, 421, 21);
        dottedLine(400, 315, 361, 344, 8);
     
        //mouse_x = mouseX;
        //mouse_y = mouseY;
        //println(mouse_y);
        
        stroke(0);
        strokeWeight(1);
        line(385, 325, 396, 340);
        line(396, 340, 411, 329);
      }
      if(t2 == 0)
        t2 = millis();
    }
    if(t - t2 > 3000 && t2 != 0 && passe1 == 0) {
      passe1 = 1;
    }
    else if(t - t2 > 5600 && passe1 == 1 && t2 != 0)
      passe1 = 2;
    else if(t - t2 > 9000 && passe1 == 2 && t2 != 0)
      passe1 = 3;
    else if(t - t2 > 13500 && passe1 == 3 && t2 != 0)
      passe1 = 4;
    else if(t - t2 > 17600 && passe1 == 4 && t2 != 0)
      passe1 = 5;

    if(passe1 == 2) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("1", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
    else if(passe1 == 3) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("2", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
     else if(passe1 == 4) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("3", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
     else if(passe1 == 5 || passe1 == 6) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("4", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
    if(passe2 == true) { //difração das ondas
      if(passe4 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      strokeWeight(2);
      pushMatrix();
      translate(400, 470 + amplitude/2);
      scale(1, -1);
      rotate(radians(144));
     //onda do segundo plano
      for(count=0; count < 605 && play == true && interf == 1; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t3)/20 && t3 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 604)
            passe4 = true;
        }
        
        if(count <= (t - t6 - 3000)/50 && t6 != 0 && count <= 27 && passe1 > 5)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 6000)/50 && t6 != 0 && count > 27 && count <= 53 && passe1 > 6)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 9000)/50 && t6 != 0 && count > 53 && count <= 79 && passe1 > 7)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 12000)/50 && t6 != 0 && count > 79 && count <= 105 && passe1 > 8)
          stroke(255, 0, 0);
        
        line(prevX, prevY, x_sin, y_sin);
        if(passe4 == true)
          stroke(255, 218, 5);
        else
          noStroke();
        prevX = x_sin;
        prevY = y_sin;
      }
     
      prevX = prevY = 0.0;
      
      popMatrix();
    }
    if(passe3 == true) {  
      //onda do primeiro plano
      pushMatrix();
      translate(400, 300 + amplitude/2);
      scale(1, -1);
      rotate(radians(144));
      if(passe5 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      for(int count=0; count < 500 && play == true && interf == 1; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t4)/20 && t4 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 499)
            passe5 = true;
        }
        
        line(prevX, prevY, x_sin, y_sin);
        
        prevX = x_sin;
        prevY = y_sin;
        if(passe5 == false)
          noStroke();
        else
          stroke(255, 218, 5);
      }
     
      prevX = prevY = 0.0;
      
      popMatrix();
       
    }
    if(passe4 == true && passe1 >= 5) {
      if(passe6 == true) {
        stroke(0);
        fill(0);
        dottedLine(401, 314, 315, 420, 21);
        dottedLine(401, 314, 442, 346, 8);
     
        //mouse_x = mouseX;
        //mouse_y = mouseY;
        //println(mouse_x);
        
        stroke(0);
        strokeWeight(1);
        line(388, 329, 403, 340);
        line(403, 340, 415, 325);
        if(t6 == 0)
          t6 = millis();
        else if(t - t6 > 3000 && passe1 == 5 && t6 != 0)
          passe1 = 6;
        else if(t - t6 > 5600 && passe1 == 6 && t6 != 0)
          passe1 = 7;
        else if(t - t6 > 9000 && passe1 == 7 && t6 != 0)
          passe1 = 8;
        else if(t - t6 > 13500 && passe1 == 8 && t6 != 0) 
          passe1 = 9;
        else if(t - t6 > 17600 && passe1 == 9 && t6 != 0) 
          passe1 = 10;
    
        if(passe1 == 7) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("5", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
        else if(passe1 == 8) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("6", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
         else if(passe1 == 9) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("7", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
         else if(passe1 == 10) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("8", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
      }   
    }

  }
  //final do inter = 1
  else if(play == true && interf == 2) {
    //onda que atinge o segundo plano

    if(passe2 == false)
      noStroke();
    else
      stroke(255, 218, 5);
    pushMatrix();
    translate(378, 468 + amplitude/2);
    scale(1, -1);
    rotate(radians(16));
    for(count=0; count < 556 && play == true && interf == 2; ++count) {
      x_sin = count;
   
      angle_sin = radians(count);
      y_sin = sin(angle_sin*(numOfWaves/0.8));
   
      y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
      
      if(count >= -1*(time - t0 - 555*20)/20 && t0 != 0 && passe2 == false) {
        stroke(255, 218, 5);
        if(count == 19) {
          passe2 = true;
          if(t3 == 0)
            t3 = millis();
        }
      } 
      
      
      if(count <= (t - t2 - 3000)/50 && t2 != 0 && count <= 26 && passe1 > 0)
        stroke(255, 0, 0);
      if(count <= (t - t2 - 6000)/50 && t2 != 0 && count > 26 && count <= 52 && passe1 > 1)
        stroke(255, 0, 0);
      if(count <= (t - t2 - 9000)/50 && t2 != 0 && count > 52 && count <= 78 && passe1 > 2)
        stroke(255, 0, 0);
       
      if(count < 19)
        noStroke();
      line(prevX, prevY, x_sin, y_sin);
      if(passe2 == true && count >= 19)
        stroke(255, 218, 5);
    
      prevX = x_sin;
      prevY = y_sin;
    }
   
    prevX = prevY = 0.0;
    
    popMatrix();
    //onda que atinge o primeiro plano
    pushMatrix();
    //translate(378, 298 + amplitude/2);
    translate(400, 300 + amplitude/2);
    scale(1, -1);
    rotate(radians(16));
    if(passe2 == false)
      noStroke();
    else
      stroke(255, 218, 5);
    for(int count=0; count < 502 && play == true && interf == 2; ++count) {
      x_sin = count;
   
      angle_sin = radians(count);
      y_sin = sin(angle_sin*(numOfWaves/0.8));
   
      y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
      
      if(count >= -1*(time - t0 - 501*20)/20 && t0 != 0 && passe2 == false) {
        stroke(255, 218, 5);
        if(count == 0) { //antes era 19
          passe3 = true;
          if(t4 == 0)
            t4 = millis();
        }
      }
      //if(count < 19)
        //noStroke();
   
      line(prevX, prevY, x_sin, y_sin);
      
      if(passe2 == true /*&& count >= 19*/)
        stroke(255, 218, 5);
      prevX = x_sin;
      prevY = y_sin;
    }
   
    prevX = prevY = 0.0;
    
    popMatrix();  
    
    
    //começa aqui
    time = millis();
    if(next == 0) {
      textFont(fonte5);
      text("O raios-X 3 e 4 são paralelos e incidem no cristal em fase. O ângulo de incidência é de 16°. O raio 3 incide no primeiro plano atômico do cristal e o raio 4, no segundo plano atômico. Assim, os raios-X percorrem caminhos de comprimentos diferentes. O raio 4 percorre o caminho mais longo.", 30, 530, 740, 100);
      if(passe4 == true && passe5 == true) {
        image(forw, 740, 600, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 622); 
      }
    }
    else if(next == 1) {
      textFont(fonte6);
      text("Os mínimos de difração são resultado da interferência totalmente destrutiva, que acontece quando a diferença de percurso entre os raios-X corresponde a um número inteiro de comprimentos de onda mais meio. A diferença de percurso dos raios incidentes é delimitada pela reta pontilhada partindo do ponto de incidência do raio 3, com direção perpendicular à direção de propagação do feixe incidente. Observe a contagem dos comprimentos de onda contidos na diferença de caminho dos raios incidentes, destacados em vermelho.", 20, 530, 760, 250);
      if(passe1 == 4) {
        image(forw, 740, 610, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 632);
      }
    }
    else if(next == 2) {
      textFont(fonte6);
      text("Para delimitar a diferença de percurso dos raios difratados, traça-se uma reta pontilhada partindo do átomo de incidência do raio 3, perpendicularmente à direção de propagação do feixe difratado. Note que os comprimentos de onda contidos na diferença de percurso são contados e destacados em vermelho. Como você pode verificar ao fim da animação, são 4 1/2 os comprimentos de onda contidos na diferença de caminho total. Consequentemente, há interferência destrutiva e o ângulo de incidência de 16° configura um mínimo de difração. Observe que, a partir da linha pontilhada, os raios difratados estão em oposição de fase.", 15, 515, 770, 200);
      if(passe1 == 8) {
        image(ret, 740, 615, 24, 24);
        textFont(fonte4);
        text("Reiniciar", 694, 632);
      }
    }
    t = millis();
    if(t1 == 0 && next == 1)
      t1 = millis();
    if(t - t1 > 3000 && t1 != 0) {
      if(passe6 == false) {
        stroke(0);
        fill(0);
        dottedLine(400, 315, 452, 460, 21);
        dottedLine(400, 315, 350, 330, 8);
        
        stroke(0);
        strokeWeight(1);
        line(381, 319, 388, 340);
        line(388, 340, 407, 334);
      }
      if(t2 == 0)
        t2 = millis();
    }
    if(t - t2 > 3000 && t2 != 0 && passe1 == 0) {
      passe1 = 1;
    }
    else if(t - t2 > 5600 && passe1 == 1 && t2 != 0)
      passe1 = 2;
    else if(t - t2 > 9000 && passe1 == 2 && t2 != 0)
      passe1 = 3;
    else if(t - t2 > 13500 && passe1 == 3 && t2 != 0)
      passe1 = 4;

    if(passe1 == 2) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("1/4", 453, 497);
      fill(0);
      text("               x ", 453, 497);
      image(lambda, 498, 480, 18, 18);
    }
    else if(passe1 == 3) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("1 1/4", 453, 497);
      fill(0);
      text("               x ", 453, 497);
      image(lambda, 498, 480, 18, 18);
    }
     else if(passe1 == 4 || passe1 == 5) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("2 1/4", 453, 497);
      fill(0);
      text("               x ", 453, 497);
      image(lambda, 498, 480, 18, 18);
    }
    
    if(passe2 == true) { //difração das ondas
      if(passe4 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      strokeWeight(2);
      pushMatrix();
      
      translate(409, 464 + amplitude/2);
      scale(1, -1);
      rotate(radians(164));
     //onda do segundo plano
     
      for(count=0; count < 575 && play == true && interf == 2; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t3)/20 && t3 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 574)
            passe4 = true;
        }
        
        if(count <= (t - t6 - 3000)/50 && t6 != 0 && count <= 13 && passe1 > 4)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 6000)/50 && t6 != 0 && count > 13 && count <= 39 && passe1 > 5)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 9000)/50 && t6 != 0 && count > 39 && count <= 65 && passe1 > 6)
          stroke(255, 0, 0);

        
        if(count < 8)
          noStroke();
        line(prevX, prevY, x_sin, y_sin);
        if(passe4 == true && count >= 8)
          stroke(255, 218, 5);
        else if(passe4 == false)
          noStroke();
        
        prevX = x_sin;
        prevY = y_sin;
      }
     
      prevX = prevY = 0.0;
      
      popMatrix();
    }
    if(passe3 == true) {  
      //onda do primeiro plano
      pushMatrix();
      //translate(409, 294 + amplitude/2);
      translate(400, 300 + amplitude/2);
      scale(1, -1);
      rotate(radians(164));
      if(passe5 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      for(int count=0; count < 470 && play == true && interf == 2; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t4)/20 && t4 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 469)
            passe5 = true;
        }
        line(prevX, prevY, x_sin, y_sin);
        if(passe4 == true)
          stroke(255, 218, 5);
        else if(passe4 == false)
          noStroke();
        
        prevX = x_sin;
        prevY = y_sin;
        if(passe5 == false)
          noStroke();
        else
          stroke(255, 218, 5);
      }
     
      prevX = prevY = 0.0;
      
      popMatrix();
       
    }
    if(passe4 == true && passe1 >= 4) {
      if(passe6 == true) {
        stroke(0);
        fill(0);
        dottedLine(401, 314, 348, 458, 21); //arrumar aqui
        dottedLine(401, 314, 449, 331, 8);
     
        //mouse_x = mouseX;
        //mouse_y = mouseY;
        //println(mouse_y);
        
        stroke(0);
        strokeWeight(1);
        line(393, 334, 413, 340); //arrumar aqui
        line(413, 340, 419, 321);
        if(t6 == 0)
          t6 = millis();
        else if(t - t6 > 3000 && passe1 == 4 && t6 != 0)
          passe1 = 5;
        else if(t - t6 > 5600 && passe1 == 5 && t6 != 0)
          passe1 = 6;
        else if(t - t6 > 9000 && passe1 == 6 && t6 != 0)
          passe1 = 7;
        else if(t - t6 > 13500 && passe1 == 7 && t6 != 0) 
          passe1 = 8;
    
        if(passe1 == 6) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("2 1/2", 297, 497);
          fill(0);
          text("               x ", 297, 497);
          image(lambda, 347, 480, 18, 18);
        }
        else if(passe1 == 7) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("3 1/2", 297, 497);
          fill(0);
          text("               x ", 297, 497);
          image(lambda, 347, 480, 18, 18);
        }
         else if(passe1 == 8) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("4 1/2", 297, 497);
          fill(0);
          text("               x ", 297, 497);
          image(lambda, 347, 480, 18, 18);
        }
      }   
    }
  
  }
  //final do if play == true
  
  popMatrix(); //fim do translate
  if(window == 0) {
    strokeJoin(BEVEL);
    strokeWeight(4);
    stroke(204, 0, 0);
    fill(204, 0, 0);
    rect(40, 35, 140, 30);
    rect(40, 85, 140, 30);
    rect(620, 35, 140, 30);
    rect(620, 85, 140, 30);
    fill(255);
    textFont(fonte3);
    textAlign(CENTER);
    text("Créditos", 40, 40, 140, 30);
    text("Processing", 40, 90, 140, 30);
    text("Introdução", 620, 40, 140, 30);
    text("Referências", 620, 90, 140, 30);
    textAlign(LEFT);
  }
  else if(window == 1) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Introdução", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar à animação", 610, 40); 
    if(sub_w == 1) {
      textFont(fonte6);
      text("A difração de raios-X é amplamente empregada em Ciência e Engenharia de Materiais. O padrão de difração de feixes de raios-X incidentes em vários ângulos sobre um determinado cristal fornece inúmeras informações acerca do seu arranjo atômico ou molecular. \nA " +
      "difração ocorre quando um feixe de ondas encontra uma série de obstáculos regularmente espaçados, capazes de espalhá-lo, e de magnitude comparável à do comprimento de onda do feixe. As ondas incidentes estão inicialmente em fase, por pertencerem todas ao mesmo feixe; no entanto, por percorrerem caminhos diferentes para atravessar os obstáculos, essas ondas deixam o cristal com uma relação de fases dependente do ângulo de incidência e do " +
      "comprimento dos obstáculos.\nA relação de fases das ondas difratadas apresenta dois casos extremos: os máximos de difração, para os quais ocorre interferência totalmente construtiva, e os mínimos de difração, para os quais a interferência é totalmente destrutiva. A interferência construtiva está ilustrada na Figura 1. Nessa figura, você pode notar que, após o " +
      "espalhamento, as ondas permanecem em fase e se somam, resultando em uma onda com o dobro de amplitude. A condição necessária para que isso aconteça é que a diferença de percurso das duas ondas contenha um número inteiro de comprimentos de onda.", 50, 80, 700, 400);
      image(constr, 175, 345, 450, 225);
      text("Figura 1: Interferência construtiva.", 400, 337);
      textFont(fonte7);
      text("Extraída de 'Materials Science and Engineering: An Introduction, 8th edition, William D. Callister e David G. Rethwisch (modificada).", 180, 567, 440, 100);
      image(forw, 714, 550);
    }
    else if(sub_w == 2) {
      textFont(fonte6);
      text("A interferência destrutiva está ilustrada na Figura 2. Após o espalhamento, as ondas deixam os obstáculos em oposição de fase e, assim, se anulam. Isso acontece quando a diferença de percurso das ondas equivale a (n + ½) x      , sendo n um número inteiro e       o " +
      "comprimento de onda.\nUma condição necessária, porém insuficiente para a difração de raios-X é a Lei de Bragg, que define para que ângulos de incidência ocorrem os máximos de difração:\n\n2 x d x sen      = n x      ,\n\nem que d é a distância interplanar,      o " +
      "complemento do ângulo de incidência, n a ordem do máximo de difração e       o comprimento de onda, como ilustrado na Figura 3.", 50, 80, 700, 400);
      image(lambda, 641, 100, 12, 12);
      image(lambda, 375, 117, 12, 12);
      image(theta, 398, 189, 12, 12);
      image(lambda, 441, 188, 12, 12);
      image(theta, 264, 225, 12, 12);
      image(lambda, 709, 224, 12, 12);
      image(destr, 20, 330, 390, 184);
      image(bragg, 430, 330, 350, 184);
      text("Figura 2: Interferência destrutiva.", 215, 310);
      text("Figura 3: Lei de Bragg.", 605, 310);
      textFont(fonte7);
      text("Figuras extraídas de 'Materials Science and Engineering: An Introduction, 8th edition, William D. Callister e David G. Rethwisch (modificadas).", 400, 540);
      image(forw, 714, 550);
      image(back, 54, 550);
    }
    else if(sub_w == 3) {
      textFont(fonte4);
      text("O objetivo desta animação é fornecer uma abordagem mais qualitativa e visual da Lei de Bragg do que a proporcionada pela equação, relevando que para que os máximos de difração ocorram , a diferença de percurso dos raios-X (de valor 2 x d x sen    ) deve conter um " +
      "número inteiro de comprimentos de onda (n x     ) – como você pode verificar assistindo à animação com o botão ‘Máximos’ ativado. Complementando o entendimento dos máximos de difração, os mínimos de difração acontecem quando a diferença de percurso entre os raios-X " +
      "equivale a um número inteiro de comprimentos de onda mais meio comprimento de onda. Para verificar esse fato, mantenha o botão ‘Mínimos’ ativado e assista à animação.", 80, 150, 640, 400);
      image(back, 54, 550);
      image(theta, 353, 232, 20, 20);
      image(lambda, 337, 259, 18, 18);
    }
  }
  else if (window == 2) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Referências", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar à animação", 610, 40);
    textFont(fonte6);
    text("CALLISTER, William D.; RETHWISCH, David G. Materials science and engineering: an introduction. 8a. ed. Nova York: John Wiley and Sons, 2009. pp. 74-77.\n\n" +
    "Universidade Federal do Rio Grande do Sul - UFRGS. 'Capítulo 5 - Raios-X'. Física Moderna. http://www.webliminal.com/search/search-web13.html\nAcesso em 16 fev. 2013" +
    "\n\nAZEVEDO Jr., Walter F. 'Difração de raios-X'. http://azevedolab.dominiotemporario.com/doc/diffraction1.pdf\nAcesso em 16 fev. 2013\n\n" +
    "Laboratório de Material Didático Multimídia - CETEC-MG. 'Capítulo 04 - Índices Cristalográficos e Difração de Raios-X'. Ciência dos Materiais Multimídia. http://www.cienciadosmateriais.org/index.php?acao=exibir&cap=9&top=104\nAcesso em 16 fev. 2013", 40, 90, 720, 400);
    fill(255, 0 , 0);
    text("Referências de imagens/ícones", 400, 375);
    fill(0);
    text("\n\nhttp://www.iconlooker.com/icon/axialis-axialis-round-web2-red-png-player-play_w714.html. Acesso em 3 fev. 2013\n\nhttp://www.iconesbr.net/down_ico/7888/symbol_forward_2. Acesso em 8 fev. 2013\n\n" +
    "http://wallpaperdojo.com/3Dwallpapers/Wallpaperdojo_3D_Spheres_Wallpaper_Black_White_20/3Dwallpapers-wallpapers.html. Acesso em 10 set. 2012\n\nhttp://www.iconesbr.net/down_ico/6980/setas. Acesso em 28 jan. 2013", 40, 375, 720, 300);
    image(start, 12, 410, 16, 16);
    image(forw, 12, 444, 20, 20);
    image(atomo, 12, 479, 18, 18);
    image(ret, 12, 535, 18, 18);
  }
  else if(window == 3) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Créditos", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar à animação", 610, 40);
    text("Desenvolvimento: Luana Ianara Rubini Ruiz (Aluna do 3º ano do Curso de Engenharia Elétrica - Sistemas Eletrônicos, Escola Politécnica da Universidade de São Paulo, São Paulo - SP, Brasil)\nOrientação: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia Metalúrgica e de Materiais, Escola Politécnica da Universidade de São Paulo, São Paulo - SP, Brasil)\nTexto: Luana Ianara Rubini Ruiz e Ivette Frida Cymbaum Oppenheim\nCriado em: Processing                    Última atualização: 21/fevereiro/2013", 60, 118, 680, 420);
    text("\nApoio: A animação 'Difração de Raios-X - Lei de Bragg' foi desenvolvida no contexto do projeto 'Animações para disciplinas Introdutórias de Ciência e Engenharia dos Materiais', integrante do 'Programa Ensinar com Pesquisa' da Pró-Reitoria de Graduação da Universidade de São Paulo, à qual expressamos nossos agradecimentos pela concessão da bolsa de Iniciação Científica (Projeto 5767 - ano 2012).", 60, 350, 680, 420);  
  }
  else if(window == 4) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Sobre o Processing", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar à animação", 610, 40);
    text("'Processing' é uma linguagem de programação e ambiente de desenvolvimento com foco principal nas artes visuais, aproveitando-se da plataforma Java e de uma comunidade virtual intensamente atuante por meio do compartilhamento de códigos e bibliotecas através da Internet. Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisadores do Instituto de Tecnologia de Massachussets (MIT) dos E.U.A, sendo, desde sua criação em 2001, disponibilizado gratuitamente como software livre, acessível a qualquer interessado a partir do download no site ‘processing.org', onde podem ser encontradas informações adicionais sobre 'Processing'.", 120, 160, 560, 410);
  }
}

